org.apache.uima.resource

## Class ConfigurableResource_ImplBase

- java.lang.Object
- - org.apache.uima.resource.Resource_ImplBase
  - - org.apache.uima.resource.ConfigurableResource_ImplBase

- All Implemented Interfaces:
    ConfigurableResource, Resource
  Direct Known Subclasses:
    AnalysisEngineImplBase, CasConsumer_ImplBase, CasDataCollectionReader_ImplBase, CasDataConsumer_ImplBase, CasDataInitializer_ImplBase, CasInitializer_ImplBase, CollectionReader_ImplBase, FlowControllerContainer

      public abstract class ConfigurableResource_ImplBase
      extends Resource_ImplBase
      implements ConfigurableResource

  Implementation base class for `ConfigurableResource`s. Provides access to configuration parameters as well as basic reconfiguration capability. Subclasses should override the `initialize` and `reconfigure` methods to read specific configuration parameters (after calling `super.initialize` or `super.reconfigure`).

- - ### Field Summary

    - ### Fields inherited from interface org.apache.uima.resource.Resource

      `PARAM_AGGREGATE_SOFA_MAPPINGS, PARAM_CONFIG_MANAGER, PARAM_CONFIG_PARAM_SETTINGS, PARAM_EXTERNAL_OVERRIDE_SETTINGS, PARAM_PERFORMANCE_TUNING_SETTINGS, PARAM_RESOURCE_MANAGER, PARAM_UIMA_CONTEXT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConfigurableResource_ImplBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `getConfigParameterValue(String aParamName)` Looks up the value of a configuration parameter.
    `Object` | `getConfigParameterValue(String aGroupName, String aParamName)` Looks up the value of a configuration parameter in a group.
    `void` | `reconfigure()` Instructs this Resource to re-read its configuration parameter settings.
    `void` | `setConfigParameterValue(String aParamName, Object aValue)` Sets the value of a configuration parameter.
    `void` | `setConfigParameterValue(String aGroupName, String aParamName, Object aValue)` Sets the value of a configuration parameter in a group.

    - ### Methods inherited from class org.apache.uima.resource.Resource_ImplBase

      `destroy, getCasManager, getLogger, getMetaData, getRelativePathResolver, getResourceManager, getUimaContext, getUimaContextAdmin, initialize, loadUserClass, loadUserClassOrThrow, setContextHolder, setContextHolderX, setLogger, setMetaData, withContextHolder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.uima.resource.Resource

      `destroy, getLogger, getMetaData, getResourceManager, getUimaContext, getUimaContextAdmin, initialize, setLogger`

- - ### Constructor Detail

    - #### ConfigurableResource_ImplBase

          public ConfigurableResource_ImplBase()

  - ### Method Detail

    - #### getConfigParameterValue

          public Object getConfigParameterValue(String aParamName)

      Description copied from interface: `ConfigurableResource`
      Looks up the value of a configuration parameter. This method will only return the value of a parameter that is not defined in any group.

      This method returns `null` if the parameter is optional and has not been assigned a value. (For mandatory parameters, an exception is thrown during initialization if no value has been assigned.) This method also returns `null` if there is no declared configuration parameter with the specified name.

      Specified by:
        `getConfigParameterValue` in interface `ConfigurableResource`
      Parameters:
        `aParamName` - the name of a parameter that is not in any group
      Returns:
        the value of the parameter with name `aParamName`, `null` is either the parameter does not exist or it has not been assigned a value.
      See Also:
        `ConfigurableResource.getConfigParameterValue(java.lang.String)`

    - #### getConfigParameterValue

          public Object getConfigParameterValue(String aGroupName,
                                                String aParamName)

      Description copied from interface: `ConfigurableResource`
      Looks up the value of a configuration parameter in a group. If the parameter has no value assigned within the group, fallback strategies will be followed.

      This method returns `null` if the parameter is optional and has not been assigned a value. (For mandatory parameters, an exception is thrown during initialization if no value has been assigned.) This method also returns `null` if there is no declared configuration parameter with the specified name.

      Specified by:
        `getConfigParameterValue` in interface `ConfigurableResource`
      Parameters:
        `aGroupName` - the name of a configuration group. If the group name is `null`, this method will return the same value as `getParameterValue(String)`.
        `aParamName` - the name of a parameter in the group
      Returns:
        the value of the parameter in group `aGroupName` with name `aParamName`,,`null` is either the parameter does not exist or it has not been assigned a value.
      See Also:
        `ConfigurableResource.getConfigParameterValue(java.lang.String, java.lang.String)`

    - #### setConfigParameterValue

          public void setConfigParameterValue(String aParamName,
                                              Object aValue)

      Description copied from interface: `ConfigurableResource`
      Sets the value of a configuration parameter. This only works for a parameter that is not defined in any group. Note that there is no guarantee that the change will take effect until `ConfigurableResource.reconfigure()` is called.
      Specified by:
        `setConfigParameterValue` in interface `ConfigurableResource`
      Parameters:
        `aParamName` - the name of a parameter that is not in any group
        `aValue` - the value to assign to the parameter
      See Also:
        `ConfigurableResource.setConfigParameterValue(java.lang.String, java.lang.Object)`

    - #### setConfigParameterValue

          public void setConfigParameterValue(String aGroupName,
                                              String aParamName,
                                              Object aValue)

      Description copied from interface: `ConfigurableResource`
      Sets the value of a configuration parameter in a group. Note that there is no guarantee that the change will take effect until `ConfigurableResource.reconfigure()` is called.
      Specified by:
        `setConfigParameterValue` in interface `ConfigurableResource`
      Parameters:
        `aGroupName` - the name of a configuration group. If this parameter is `null`, this method will have the same effect as `setParameterValue(String,Object)`.
        `aParamName` - the name of a parameter in the group
        `aValue` - the value to assign to the parameter.
      See Also:
        `ConfigurableResource.setConfigParameterValue(java.lang.String, java.lang.String, java.lang.Object)`

    - #### reconfigure

          public void reconfigure()
                           throws ResourceConfigurationException

      Description copied from interface: `ConfigurableResource`
      Instructs this Resource to re-read its configuration parameter settings.
      Specified by:
        `reconfigure` in interface `ConfigurableResource`
      Throws:
        `ResourceConfigurationException` - if the configuration is not valid
      See Also:
        `ConfigurableResource.reconfigure()`

Copyright © 2006–2022 The Apache Software Foundation. All rights reserved.